"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reducer = exports["default"] = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _objectDestructuringEmpty2 = _interopRequireDefault(require("@babel/runtime/helpers/objectDestructuringEmpty"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _useFormApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));
var _fieldArray = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/field-array"));
var _isEqual = _interopRequireDefault(require("lodash/isEqual"));
var _Grid = _interopRequireDefault(require("@mui/material/Grid"));
var _Button = _interopRequireDefault(require("@mui/material/Button"));
var _Typography = _interopRequireDefault(require("@mui/material/Typography"));
var _FormControl = _interopRequireDefault(require("@mui/material/FormControl"));
var _FormHelperText = _interopRequireDefault(require("@mui/material/FormHelperText"));
var _IconButton = _interopRequireDefault(require("@mui/material/IconButton"));
var _Redo = _interopRequireDefault(require("@mui/icons-material/Redo"));
var _Undo = _interopRequireDefault(require("@mui/icons-material/Undo"));
var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));
var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));
var _clsx = _interopRequireDefault(require("clsx"));
var _excluded = ["remove"],
  _excluded2 = ["remove"],
  _excluded3 = ["arrayValidator", "label", "description", "fields", "defaultItem", "meta", "minItems", "maxItems", "noItemsMessage", "FormFieldGridProps", "FormControlProps", "buttonLabels", "GridContainerProps", "HeaderGridProps", "HeaderProps", "UndoButtonProps", "RedoButtonProps", "AddButtonProps", "DescriptionGridProps", "DescriptionProps", "BodyGridProps", "NoItemsProps", "FormHelperTextGridProps", "FormHelperTextProps", "FieldContainerProps", "FieldGroupGridProps", "RemoveButtonGridProps", "RemoveButtonProps"];
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var PREFIX = 'DynamicArray';
var classes = {
  formControl: "".concat(PREFIX, "-formControl"),
  centerText: "".concat(PREFIX, "-centerText"),
  buttonsToEnd: "".concat(PREFIX, "-buttonsToEnd"),
  header: "".concat(PREFIX, "-header"),
  label: "".concat(PREFIX, "-label"),
  fieldArrayGroup: "".concat(PREFIX, "-fieldArrayGroup")
};
var StyledFormFieldGrid = (0, _styles.styled)(_formFieldGrid["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])({}, "& .".concat(classes.formControl), {
  width: '100%'
}), "& .".concat(classes.centerText), {
  display: 'flex',
  justifyContent: 'center'
}), "& .".concat(classes.buttonsToEnd), {
  display: 'flex',
  justifyContent: 'flex-end'
}), "& .".concat(classes.header), {
  display: 'flex'
}), "& .".concat(classes.label), {
  flexGrow: 1
}), "&.".concat(classes.fieldArrayGroup), {
  marginBottom: 32
}));
var ArrayItem = /*#__PURE__*/(0, _react.memo)(function (_ref) {
  var fields = _ref.fields,
    fieldIndex = _ref.fieldIndex,
    name = _ref.name,
    remove = _ref.remove,
    length = _ref.length,
    minItems = _ref.minItems,
    removeLabel = _ref.removeLabel,
    _ref$FieldContainerPr = _ref.FieldContainerProps,
    FieldContainerProps = _ref$FieldContainerPr === void 0 ? {} : _ref$FieldContainerPr,
    _ref$FieldGroupGridPr = _ref.FieldGroupGridProps,
    FieldGroupGridProps = _ref$FieldGroupGridPr === void 0 ? {} : _ref$FieldGroupGridPr,
    _ref$RemoveButtonGrid = _ref.RemoveButtonGridProps,
    RemoveButtonGridProps = _ref$RemoveButtonGrid === void 0 ? {} : _ref$RemoveButtonGrid,
    _ref$RemoveButtonProp = _ref.RemoveButtonProps,
    RemoveButtonProps = _ref$RemoveButtonProp === void 0 ? {} : _ref$RemoveButtonProp;
  var _useFormApi = (0, _useFormApi2["default"])(),
    renderForm = _useFormApi.renderForm;
  var editedFields = fields.map(function (field, index) {
    var computedName = field.name ? "".concat(name, ".").concat(field.name) : name;
    return _objectSpread(_objectSpread({}, field), {}, {
      name: computedName,
      key: "".concat(computedName, "-").concat(index)
    });
  });
  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    container: true,
    spacing: 3
  }, FieldContainerProps), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12
  }, FieldGroupGridProps), /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
    container: true,
    spacing: 3
  }, renderForm([editedFields]))), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12,
    className: classes.buttonsToEnd
  }, RemoveButtonGridProps), /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    color: "secondary",
    onClick: function onClick() {
      return remove(fieldIndex);
    },
    disabled: length <= minItems
  }, RemoveButtonProps), removeLabel)));
}, function (_ref2, _ref3) {
  var _prevRemove = _ref2.remove,
    prev = (0, _objectWithoutProperties2["default"])(_ref2, _excluded);
  var _nextRemove = _ref3.remove,
    next = (0, _objectWithoutProperties2["default"])(_ref3, _excluded2);
  return (0, _isEqual["default"])(prev, next);
});
var defaultButtonLabels = {
  add: 'ADD',
  remove: 'REMOVE'
};
var initialState = {
  index: 0,
  history: []
};
var reducer = exports.reducer = function reducer(state, _ref4) {
  var type = _ref4.type,
    action = _ref4.action;
  switch (type) {
    case 'redo':
      return _objectSpread(_objectSpread({}, state), {}, {
        index: state.index + 1
      });
    case 'action':
      return {
        index: state.index + 1,
        history: [].concat((0, _toConsumableArray2["default"])(state.history.slice(0, state.index)), [action])
      };
    case 'undo':
      return _objectSpread(_objectSpread({}, state), {}, {
        index: state.index - 1
      });
    case 'resetHistory':
      return _objectSpread(_objectSpread({}, state), {}, {
        history: state.history.slice(0, state.index)
      });
    default:
      return state;
  }
};
var DynamicArray = function DynamicArray(_ref5) {
  var props = (0, _extends2["default"])({}, ((0, _objectDestructuringEmpty2["default"])(_ref5), _ref5));
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
    arrayValidator = _useFieldApi.arrayValidator,
    label = _useFieldApi.label,
    description = _useFieldApi.description,
    formFields = _useFieldApi.fields,
    defaultItem = _useFieldApi.defaultItem,
    meta = _useFieldApi.meta,
    _useFieldApi$minItems = _useFieldApi.minItems,
    minItems = _useFieldApi$minItems === void 0 ? 0 : _useFieldApi$minItems,
    _useFieldApi$maxItems = _useFieldApi.maxItems,
    maxItems = _useFieldApi$maxItems === void 0 ? Infinity : _useFieldApi$maxItems,
    _useFieldApi$noItemsM = _useFieldApi.noItemsMessage,
    noItemsMessage = _useFieldApi$noItemsM === void 0 ? 'No items added' : _useFieldApi$noItemsM,
    _useFieldApi$FormFiel = _useFieldApi.FormFieldGridProps,
    FormFieldGridProps = _useFieldApi$FormFiel === void 0 ? {} : _useFieldApi$FormFiel,
    _useFieldApi$FormCont = _useFieldApi.FormControlProps,
    FormControlProps = _useFieldApi$FormCont === void 0 ? {} : _useFieldApi$FormCont,
    buttonLabels = _useFieldApi.buttonLabels,
    _useFieldApi$GridCont = _useFieldApi.GridContainerProps,
    GridContainerProps = _useFieldApi$GridCont === void 0 ? {} : _useFieldApi$GridCont,
    _useFieldApi$HeaderGr = _useFieldApi.HeaderGridProps,
    HeaderGridProps = _useFieldApi$HeaderGr === void 0 ? {} : _useFieldApi$HeaderGr,
    _useFieldApi$HeaderPr = _useFieldApi.HeaderProps,
    HeaderProps = _useFieldApi$HeaderPr === void 0 ? {} : _useFieldApi$HeaderPr,
    _useFieldApi$UndoButt = _useFieldApi.UndoButtonProps,
    UndoButtonProps = _useFieldApi$UndoButt === void 0 ? {} : _useFieldApi$UndoButt,
    _useFieldApi$RedoButt = _useFieldApi.RedoButtonProps,
    RedoButtonProps = _useFieldApi$RedoButt === void 0 ? {} : _useFieldApi$RedoButt,
    _useFieldApi$AddButto = _useFieldApi.AddButtonProps,
    AddButtonProps = _useFieldApi$AddButto === void 0 ? {} : _useFieldApi$AddButto,
    _useFieldApi$Descript = _useFieldApi.DescriptionGridProps,
    DescriptionGridProps = _useFieldApi$Descript === void 0 ? {} : _useFieldApi$Descript,
    _useFieldApi$Descript2 = _useFieldApi.DescriptionProps,
    DescriptionProps = _useFieldApi$Descript2 === void 0 ? {} : _useFieldApi$Descript2,
    _useFieldApi$BodyGrid = _useFieldApi.BodyGridProps,
    BodyGridProps = _useFieldApi$BodyGrid === void 0 ? {} : _useFieldApi$BodyGrid,
    _useFieldApi$NoItemsP = _useFieldApi.NoItemsProps,
    NoItemsProps = _useFieldApi$NoItemsP === void 0 ? {} : _useFieldApi$NoItemsP,
    _useFieldApi$FormHelp = _useFieldApi.FormHelperTextGridProps,
    FormHelperTextGridProps = _useFieldApi$FormHelp === void 0 ? {} : _useFieldApi$FormHelp,
    _useFieldApi$FormHelp2 = _useFieldApi.FormHelperTextProps,
    FormHelperTextProps = _useFieldApi$FormHelp2 === void 0 ? {} : _useFieldApi$FormHelp2,
    _useFieldApi$FieldCon = _useFieldApi.FieldContainerProps,
    FieldContainerProps = _useFieldApi$FieldCon === void 0 ? {} : _useFieldApi$FieldCon,
    _useFieldApi$FieldGro = _useFieldApi.FieldGroupGridProps,
    FieldGroupGridProps = _useFieldApi$FieldGro === void 0 ? {} : _useFieldApi$FieldGro,
    _useFieldApi$RemoveBu = _useFieldApi.RemoveButtonGridProps,
    RemoveButtonGridProps = _useFieldApi$RemoveBu === void 0 ? {} : _useFieldApi$RemoveBu,
    _useFieldApi$RemoveBu2 = _useFieldApi.RemoveButtonProps,
    RemoveButtonProps = _useFieldApi$RemoveBu2 === void 0 ? {} : _useFieldApi$RemoveBu2,
    rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded3);
  var _useReducer = (0, _react.useReducer)(reducer, initialState),
    _useReducer2 = (0, _slicedToArray2["default"])(_useReducer, 2),
    state = _useReducer2[0],
    dispatch = _useReducer2[1];
  var combinedButtonLabels = _objectSpread(_objectSpread({}, defaultButtonLabels), buttonLabels);
  var dirty = meta.dirty,
    submitFailed = meta.submitFailed,
    error = meta.error,
    submitError = meta.submitError;
  var isError = (dirty || submitFailed) && error && typeof error === 'string';
  return /*#__PURE__*/_react["default"].createElement(StyledFormFieldGrid, (0, _extends2["default"])({}, FormFieldGridProps, {
    className: (0, _clsx["default"])(classes.fieldArrayGroup, FormFieldGridProps.classname)
  }), /*#__PURE__*/_react["default"].createElement(_FormControl["default"], (0, _extends2["default"])({
    component: "fieldset",
    error: isError || submitError
  }, FormControlProps, {
    className: (0, _clsx["default"])(classes.formControl, FormControlProps.className)
  }), /*#__PURE__*/_react["default"].createElement(_fieldArray["default"], {
    key: rest.input.name,
    name: rest.input.name,
    validate: arrayValidator
  }, function (_ref6) {
    var _ref6$fields = _ref6.fields,
      map = _ref6$fields.map,
      _ref6$fields$value = _ref6$fields.value,
      value = _ref6$fields$value === void 0 ? [] : _ref6$fields$value,
      push = _ref6$fields.push,
      remove = _ref6$fields.remove;
    var pushWrapper = function pushWrapper() {
      dispatch({
        type: 'resetHistory'
      });
      push(defaultItem);
    };
    var removeWrapper = function removeWrapper(index) {
      dispatch({
        type: 'action',
        action: {
          action: 'remove',
          value: value[index]
        }
      });
      remove(index);
    };
    var undo = function undo() {
      push(state.history[state.index - 1].value);
      dispatch({
        type: 'undo'
      });
    };
    var redo = function redo() {
      remove(value.length - 1);
      dispatch({
        type: 'redo'
      });
    };
    return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
      container: true,
      spacing: 3
    }, GridContainerProps), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
      item: true,
      xs: 12,
      className: classes.header
    }, HeaderGridProps), label && /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({
      variant: "h6",
      className: classes.label
    }, HeaderProps), label), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], (0, _extends2["default"])({
      color: "primary",
      "aria-label": "undo",
      component: "span",
      disabled: state.index === 0,
      onClick: undo
    }, UndoButtonProps, {
      size: "large"
    }), /*#__PURE__*/_react["default"].createElement(_Undo["default"], null)), /*#__PURE__*/_react["default"].createElement(_IconButton["default"], (0, _extends2["default"])({
      color: "primary",
      "aria-label": "redo",
      component: "span",
      disabled: state.index === state.history.length,
      onClick: redo
    }, RedoButtonProps, {
      size: "large"
    }), /*#__PURE__*/_react["default"].createElement(_Redo["default"], null)), /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
      color: "primary",
      onClick: pushWrapper,
      disabled: value.length >= maxItems
    }, AddButtonProps), combinedButtonLabels.add)), description && /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
      item: true,
      xs: 12
    }, DescriptionGridProps), /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({
      variant: "subtitle1"
    }, DescriptionProps), description)), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
      item: true,
      xs: 12
    }, BodyGridProps), value.length <= 0 ? /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({
      variant: "body1",
      gutterBottom: true,
      className: classes.centerText
    }, NoItemsProps), noItemsMessage) : map(function (name, index) {
      return /*#__PURE__*/_react["default"].createElement(ArrayItem, {
        key: name,
        fields: formFields,
        name: name,
        fieldIndex: index,
        remove: removeWrapper,
        length: value.length,
        minItems: minItems,
        removeLabel: combinedButtonLabels.remove,
        FieldContainerProps: FieldContainerProps,
        FieldGroupGridProps: FieldGroupGridProps,
        RemoveButtonGridProps: RemoveButtonGridProps,
        RemoveButtonProps: RemoveButtonProps
      });
    })), (isError || submitError) && /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
      item: true,
      xs: 12
    }, FormHelperTextGridProps), /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], FormHelperTextProps, error || submitError)));
  })));
};
var _default = exports["default"] = DynamicArray;