"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.FormError = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _Grid = _interopRequireDefault(require("@mui/material/Grid"));
var _Button = _interopRequireDefault(require("@mui/material/Button"));
var _Typography = _interopRequireDefault(require("@mui/material/Typography"));
var _Alert = _interopRequireDefault(require("@mui/material/Alert"));
var _AlertTitle = _interopRequireDefault(require("@mui/material/AlertTitle"));
var _formTemplate = _interopRequireDefault(require("@data-driven-forms/common/form-template"));
var _clsx = _interopRequireDefault(require("clsx"));
var _excluded = ["children", "GridContainerProps", "GridProps"],
  _excluded2 = ["children", "GridProps"],
  _excluded3 = ["children", "GridProps"],
  _excluded4 = ["children", "GridProps"],
  _excluded5 = ["label", "variant", "children", "buttonType"],
  _excluded6 = ["title", "description", "TitleProps", "className"];
var PREFIX = 'MuiFormTemplate';
var classes = {
  buttonGroup: "".concat(PREFIX, "-buttonGroup")
};
var StyledButtonGroup = (0, _styles.styled)(_Grid["default"])(function () {
  return (0, _defineProperty2["default"])({}, "& .".concat(classes.buttonGroup), {
    display: 'flex',
    justifyContent: 'flex-end',
    '&>button:not(last-child)': {
      marginLeft: 8
    }
  });
});
var Form = function Form(_ref2) {
  var children = _ref2.children,
    GridContainerProps = _ref2.GridContainerProps,
    GridProps = _ref2.GridProps,
    props = (0, _objectWithoutProperties2["default"])(_ref2, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12
  }, GridProps), /*#__PURE__*/_react["default"].createElement("form", (0, _extends2["default"])({
    noValidate: true
  }, props), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    container: true,
    rowSpacing: 2,
    item: true,
    xs: 12
  }, GridContainerProps), children)));
};
var Description = function Description(_ref3) {
  var children = _ref3.children,
    GridProps = _ref3.GridProps,
    props = (0, _objectWithoutProperties2["default"])(_ref3, _excluded2);
  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12
  }, GridProps), /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({
    variant: "body1",
    gutterBottom: true
  }, props), children));
};
var Title = function Title(_ref4) {
  var children = _ref4.children,
    GridProps = _ref4.GridProps,
    props = (0, _objectWithoutProperties2["default"])(_ref4, _excluded3);
  return /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12
  }, GridProps), /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({
    variant: "h3",
    gutterBottom: true
  }, props), children));
};
var ButtonGroup = function ButtonGroup(_ref5) {
  var children = _ref5.children,
    GridProps = _ref5.GridProps,
    props = (0, _objectWithoutProperties2["default"])(_ref5, _excluded4);
  return /*#__PURE__*/_react["default"].createElement(StyledButtonGroup, (0, _extends2["default"])({
    item: true,
    xs: 12
  }, GridProps), /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
    className: classes.buttonGroup
  }, props), children));
};
var Button = function Button(_ref6) {
  var label = _ref6.label,
    variant = _ref6.variant,
    children = _ref6.children,
    buttonType = _ref6.buttonType,
    props = (0, _objectWithoutProperties2["default"])(_ref6, _excluded5);
  return /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _extends2["default"])({
    color: variant,
    variant: "contained"
  }, props), label || children);
};
var StyledAlert = (0, _styles.styled)(_Alert["default"])(function () {
  return {
    '& .alert': {
      width: '100%',
      margin: 8
    }
  };
});
var FormError = exports.FormError = function FormError(_ref7) {
  var formError = _ref7.formError,
    alertProps = _ref7.alertProps;
  if ((0, _typeof2["default"])(formError) === 'object' && (formError.title || formError.title)) {
    var title = formError.title,
      description = formError.description,
      TitleProps = formError.TitleProps,
      className = formError.className,
      props = (0, _objectWithoutProperties2["default"])(formError, _excluded6);
    return /*#__PURE__*/_react["default"].createElement(StyledAlert, (0, _extends2["default"])({
      severity: "error"
    }, props, alertProps, {
      className: (0, _clsx["default"])('alert', alertProps === null || alertProps === void 0 ? void 0 : alertProps.className, className)
    }), title && /*#__PURE__*/_react["default"].createElement(_AlertTitle["default"], TitleProps, title), description);
  }
  if (formError) {
    return /*#__PURE__*/_react["default"].createElement(StyledAlert, (0, _extends2["default"])({
      severity: "error"
    }, alertProps, {
      className: (0, _clsx["default"])('alert', alertProps === null || alertProps === void 0 ? void 0 : alertProps.className)
    }), formError);
  }
  return null;
};
var MuiFormTemplate = function MuiFormTemplate(props) {
  return /*#__PURE__*/_react["default"].createElement(_formTemplate["default"], (0, _extends2["default"])({
    BeforeError: FormError,
    FormWrapper: Form,
    Button: Button,
    ButtonGroup: ButtonGroup,
    Title: Title,
    Description: Description
  }, props));
};
var _default = exports["default"] = MuiFormTemplate;