"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _Radio = _interopRequireDefault(require("@mui/material/Radio"));
var _FormControlLabel = _interopRequireDefault(require("@mui/material/FormControlLabel"));
var _FormControl = _interopRequireDefault(require("@mui/material/FormControl"));
var _FormLabel = _interopRequireDefault(require("@mui/material/FormLabel"));
var _FormHelperText = _interopRequireDefault(require("@mui/material/FormHelperText"));
var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));
var _validationError = require("../validation-error/validation-error");
var _useFieldApi3 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));
var _excluded = ["inputProps"],
  _excluded2 = ["name", "option", "isDisabled", "isReadOnly", "FormControlLabelProps", "RadioProps"],
  _excluded3 = ["name"],
  _excluded4 = ["options", "isDisabled", "label", "isRequired", "helperText", "description", "isReadOnly", "meta", "validateOnMount", "FormFieldGridProps", "FormControlProps", "FormLabelProps", "FormHelperTextProps", "FormControlLabelProps", "RadioProps"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var PREFIX = 'Radio';
var classes = {
  grid: "".concat(PREFIX, "-grid")
};
var StyledFormFieldGrid = (0, _styles.styled)(_formFieldGrid["default"])(function () {
  return (0, _defineProperty2["default"])({}, "&.".concat(classes.grid), {
    '&:first-of-type': {
      marginTop: 8
    }
  });
});
var RadioOption = function RadioOption(_ref2) {
  var name = _ref2.name,
    option = _ref2.option,
    isDisabled = _ref2.isDisabled,
    isReadOnly = _ref2.isReadOnly,
    FormControlLabelProps = _ref2.FormControlLabelProps,
    _ref2$RadioProps = _ref2.RadioProps,
    inputProps = _ref2$RadioProps.inputProps,
    RadioProps = (0, _objectWithoutProperties2["default"])(_ref2$RadioProps, _excluded),
    props = (0, _objectWithoutProperties2["default"])(_ref2, _excluded2);
  var _useFieldApi = (0, _useFieldApi3["default"])({
      name: name,
      type: 'radio',
      value: option.value
    }),
    input = _useFieldApi.input;
  return /*#__PURE__*/_react["default"].createElement(_FormControlLabel["default"], (0, _extends2["default"])({
    key: "".concat(name, "-").concat(option.value),
    control: /*#__PURE__*/_react["default"].createElement(_Radio["default"], (0, _extends2["default"])({}, input, {
      name: name,
      disabled: isDisabled || isReadOnly,
      onChange: function onChange() {
        return input.onChange(option.value);
      },
      inputProps: _objectSpread({
        readOnly: isReadOnly
      }, inputProps)
    }, RadioProps)),
    label: option.label
  }, FormControlLabelProps, props));
};
var Radio = function Radio(_ref3) {
  var name = _ref3.name,
    props = (0, _objectWithoutProperties2["default"])(_ref3, _excluded3);
  var _useFieldApi2 = (0, _useFieldApi3["default"])(_objectSpread(_objectSpread({}, props), {}, {
      name: name,
      type: 'radio'
    })),
    _useFieldApi2$options = _useFieldApi2.options,
    options = _useFieldApi2$options === void 0 ? [] : _useFieldApi2$options,
    isDisabled = _useFieldApi2.isDisabled,
    label = _useFieldApi2.label,
    isRequired = _useFieldApi2.isRequired,
    helperText = _useFieldApi2.helperText,
    description = _useFieldApi2.description,
    isReadOnly = _useFieldApi2.isReadOnly,
    meta = _useFieldApi2.meta,
    validateOnMount = _useFieldApi2.validateOnMount,
    _useFieldApi2$FormFie = _useFieldApi2.FormFieldGridProps,
    FormFieldGridProps = _useFieldApi2$FormFie === void 0 ? {} : _useFieldApi2$FormFie,
    _useFieldApi2$FormCon = _useFieldApi2.FormControlProps,
    FormControlProps = _useFieldApi2$FormCon === void 0 ? {} : _useFieldApi2$FormCon,
    _useFieldApi2$FormLab = _useFieldApi2.FormLabelProps,
    FormLabelProps = _useFieldApi2$FormLab === void 0 ? {} : _useFieldApi2$FormLab,
    _useFieldApi2$FormHel = _useFieldApi2.FormHelperTextProps,
    FormHelperTextProps = _useFieldApi2$FormHel === void 0 ? {} : _useFieldApi2$FormHel,
    _useFieldApi2$FormCon2 = _useFieldApi2.FormControlLabelProps,
    FormControlLabelProps = _useFieldApi2$FormCon2 === void 0 ? {} : _useFieldApi2$FormCon2,
    _useFieldApi2$RadioPr = _useFieldApi2.RadioProps,
    RadioProps = _useFieldApi2$RadioPr === void 0 ? {} : _useFieldApi2$RadioPr,
    rest = (0, _objectWithoutProperties2["default"])(_useFieldApi2, _excluded4);
  var invalid = (0, _validationError.validationError)(meta, validateOnMount);
  var text = invalid || (meta.touched || validateOnMount) && meta.warning || helperText || description;
  return /*#__PURE__*/_react["default"].createElement(StyledFormFieldGrid, (0, _extends2["default"])({
    className: classes.grid
  }, FormFieldGridProps), /*#__PURE__*/_react["default"].createElement(_FormControl["default"], (0, _extends2["default"])({
    required: isRequired,
    error: !!invalid,
    component: "fieldset"
  }, FormControlProps), /*#__PURE__*/_react["default"].createElement(_FormLabel["default"], (0, _extends2["default"])({
    component: "legend"
  }, FormLabelProps), label), options.map(function (option) {
    return /*#__PURE__*/_react["default"].createElement(RadioOption, (0, _extends2["default"])({
      key: option.value,
      name: name,
      option: option,
      isDisabled: isDisabled,
      isReadOnly: isReadOnly,
      FormControlLabelProps: FormControlLabelProps,
      RadioProps: RadioProps
    }, rest));
  }), text && /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], FormHelperTextProps, text)));
};
var _default = exports["default"] = Radio;