"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireDefault(require("react"));
var _FormControl = _interopRequireDefault(require("@mui/material/FormControl"));
var _FormGroup = _interopRequireDefault(require("@mui/material/FormGroup"));
var _FormHelperText = _interopRequireDefault(require("@mui/material/FormHelperText"));
var _Slider = _interopRequireDefault(require("@mui/material/Slider"));
var _FormLabel = _interopRequireDefault(require("@mui/material/FormLabel"));
var _Grid = _interopRequireDefault(require("@mui/material/Grid"));
var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));
var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));
var _validationError = require("../validation-error/validation-error");
var _excluded = ["input", "isReadOnly", "isDisabled", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "FormFieldGridProps", "FormControlProps", "FormGroupProps", "FormLabelProps", "FormHelperTextProps", "before", "after", "InputGridProps", "BeforeGridProps", "SliderGridProps", "AfterGridProps"];
var Slider = function Slider(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
    input = _useFieldApi.input,
    isReadOnly = _useFieldApi.isReadOnly,
    isDisabled = _useFieldApi.isDisabled,
    isRequired = _useFieldApi.isRequired,
    label = _useFieldApi.label,
    helperText = _useFieldApi.helperText,
    description = _useFieldApi.description,
    validateOnMount = _useFieldApi.validateOnMount,
    meta = _useFieldApi.meta,
    FormFieldGridProps = _useFieldApi.FormFieldGridProps,
    FormControlProps = _useFieldApi.FormControlProps,
    FormGroupProps = _useFieldApi.FormGroupProps,
    FormLabelProps = _useFieldApi.FormLabelProps,
    FormHelperTextProps = _useFieldApi.FormHelperTextProps,
    before = _useFieldApi.before,
    after = _useFieldApi.after,
    InputGridProps = _useFieldApi.InputGridProps,
    BeforeGridProps = _useFieldApi.BeforeGridProps,
    SliderGridProps = _useFieldApi.SliderGridProps,
    AfterGridProps = _useFieldApi.AfterGridProps,
    rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);
  var invalid = (0, _validationError.validationError)(meta, validateOnMount);
  var text = invalid || (meta.touched || validateOnMount) && meta.warning || helperText || description;
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], FormFieldGridProps, /*#__PURE__*/_react["default"].createElement(_FormControl["default"], (0, _extends2["default"])({
    fullWidth: true,
    required: isRequired,
    error: !!invalid,
    component: "fieldset"
  }, FormControlProps), /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], FormGroupProps, /*#__PURE__*/_react["default"].createElement(_FormLabel["default"], (0, _extends2["default"])({
    component: "legend"
  }, FormLabelProps), label), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    container: true,
    spacing: 2,
    alignItems: "center"
  }, InputGridProps), before && /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true
  }, BeforeGridProps), before), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: true
  }, SliderGridProps), /*#__PURE__*/_react["default"].createElement(_Slider["default"], (0, _extends2["default"])({}, input, {
    value: input.value || (rest.max + rest.min) / 2 || 50
  }, rest, {
    disabled: isDisabled || isReadOnly,
    onChange: function onChange(_e, value) {
      return input.onChange(value);
    }
  }))), after && /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true
  }, AfterGridProps), after)), text && /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], FormHelperTextProps, text))));
};
var _default = exports["default"] = Slider;