"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _Typography = _interopRequireDefault(require("@mui/material/Typography"));
var _Grid = _interopRequireDefault(require("@mui/material/Grid"));
var _useFormApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));
var _excluded = ["fields", "title", "description", "component", "TitleGridProps", "TitleProps", "DescriptionProps", "DescriptionGridProps", "ItemsGridProps"];
var PREFIX = 'SubForm';
var classes = {
  grid: "".concat(PREFIX, "-grid")
};
var StyledGrid = (0, _styles.styled)(_Grid["default"])(function () {
  return (0, _defineProperty2["default"])({}, "&.".concat(classes.grid), {
    paddingRight: 0,
    paddingLeft: 0
  });
});
var SubForm = function SubForm(_ref2) {
  var fields = _ref2.fields,
    title = _ref2.title,
    description = _ref2.description,
    component = _ref2.component,
    TitleGridProps = _ref2.TitleGridProps,
    TitleProps = _ref2.TitleProps,
    DescriptionProps = _ref2.DescriptionProps,
    DescriptionGridProps = _ref2.DescriptionGridProps,
    ItemsGridProps = _ref2.ItemsGridProps,
    rest = (0, _objectWithoutProperties2["default"])(_ref2, _excluded);
  var _useFormApi = (0, _useFormApi2["default"])(),
    renderForm = _useFormApi.renderForm;
  return /*#__PURE__*/_react["default"].createElement(StyledGrid, (0, _extends2["default"])({
    item: true,
    xs: 12,
    container: true,
    className: classes.grid
  }, rest), title && /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12
  }, TitleGridProps), /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({
    variant: "h5"
  }, TitleProps), title)), description && /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12
  }, DescriptionGridProps), /*#__PURE__*/_react["default"].createElement(_Typography["default"], (0, _extends2["default"])({
    paragraph: true
  }, DescriptionProps), description)), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    item: true,
    xs: 12,
    container: true,
    rowSpacing: 2
  }, ItemsGridProps), renderForm(fields)));
};
var _default = exports["default"] = SubForm;