"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Switch = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireDefault(require("react"));
var _FormControlLabel = _interopRequireDefault(require("@mui/material/FormControlLabel"));
var _FormHelperText = _interopRequireDefault(require("@mui/material/FormHelperText"));
var _FormControl = _interopRequireDefault(require("@mui/material/FormControl"));
var _FormGroup = _interopRequireDefault(require("@mui/material/FormGroup"));
var _FormLabel = _interopRequireDefault(require("@mui/material/FormLabel"));
var _Switch = _interopRequireDefault(require("@mui/material/Switch"));
var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));
var _validationError = require("../validation-error/validation-error");
var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));
var _excluded = ["input", "isReadOnly", "isDisabled", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "onText", "offText", "FormFieldGridProps", "FormControlProps", "FormGroupProps", "FormControlLabelProps", "SwitchProps", "FormLabelProps", "FormHelperTextProps"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Switch = exports.Switch = function Switch(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(_objectSpread(_objectSpread({}, props), {}, {
      type: 'checkbox'
    })),
    input = _useFieldApi.input,
    isReadOnly = _useFieldApi.isReadOnly,
    isDisabled = _useFieldApi.isDisabled,
    isRequired = _useFieldApi.isRequired,
    label = _useFieldApi.label,
    helperText = _useFieldApi.helperText,
    description = _useFieldApi.description,
    validateOnMount = _useFieldApi.validateOnMount,
    meta = _useFieldApi.meta,
    onText = _useFieldApi.onText,
    offText = _useFieldApi.offText,
    _useFieldApi$FormFiel = _useFieldApi.FormFieldGridProps,
    FormFieldGridProps = _useFieldApi$FormFiel === void 0 ? {} : _useFieldApi$FormFiel,
    _useFieldApi$FormCont = _useFieldApi.FormControlProps,
    FormControlProps = _useFieldApi$FormCont === void 0 ? {} : _useFieldApi$FormCont,
    _useFieldApi$FormGrou = _useFieldApi.FormGroupProps,
    FormGroupProps = _useFieldApi$FormGrou === void 0 ? {} : _useFieldApi$FormGrou,
    _useFieldApi$FormCont2 = _useFieldApi.FormControlLabelProps,
    FormControlLabelProps = _useFieldApi$FormCont2 === void 0 ? {} : _useFieldApi$FormCont2,
    _useFieldApi$SwitchPr = _useFieldApi.SwitchProps,
    SwitchProps = _useFieldApi$SwitchPr === void 0 ? {} : _useFieldApi$SwitchPr,
    _useFieldApi$FormLabe = _useFieldApi.FormLabelProps,
    FormLabelProps = _useFieldApi$FormLabe === void 0 ? {} : _useFieldApi$FormLabe,
    _useFieldApi$FormHelp = _useFieldApi.FormHelperTextProps,
    FormHelperTextProps = _useFieldApi$FormHelp === void 0 ? {} : _useFieldApi$FormHelp,
    rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);
  var invalid = (0, _validationError.validationError)(meta, validateOnMount);
  var text = invalid || (meta.touched || validateOnMount) && meta.warning || helperText || description;
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], FormFieldGridProps, /*#__PURE__*/_react["default"].createElement(_FormControl["default"], (0, _extends2["default"])({
    required: isRequired,
    error: !!invalid,
    component: "fieldset"
  }, FormControlProps), /*#__PURE__*/_react["default"].createElement(_FormGroup["default"], FormGroupProps, /*#__PURE__*/_react["default"].createElement(_FormControlLabel["default"], (0, _extends2["default"])({
    control: /*#__PURE__*/_react["default"].createElement(_Switch["default"], (0, _extends2["default"])({}, rest, input, {
      readOnly: isReadOnly,
      disabled: isDisabled || isReadOnly,
      onChange: function onChange(_ref) {
        var checked = _ref.target.checked;
        return input.onChange(checked);
      }
    }, SwitchProps)),
    label: /*#__PURE__*/_react["default"].createElement(_FormLabel["default"], FormLabelProps, input.checked ? onText || label : offText || label)
  }, FormControlLabelProps)), text && /*#__PURE__*/_react["default"].createElement(_FormHelperText["default"], FormHelperTextProps, text))));
};
var _default = exports["default"] = Switch;