"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _react = _interopRequireDefault(require("react"));
var _TextField = _interopRequireDefault(require("@mui/material/TextField"));
var _formFieldGrid = _interopRequireDefault(require("../form-field-grid/form-field-grid"));
var _validationError = require("../validation-error/validation-error");
var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));
var _excluded = ["input", "isReadOnly", "isDisabled", "placeholder", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "FormFieldGridProps", "inputProps"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var Textarea = function Textarea(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])(props),
    input = _useFieldApi.input,
    isReadOnly = _useFieldApi.isReadOnly,
    isDisabled = _useFieldApi.isDisabled,
    placeholder = _useFieldApi.placeholder,
    isRequired = _useFieldApi.isRequired,
    label = _useFieldApi.label,
    helperText = _useFieldApi.helperText,
    description = _useFieldApi.description,
    validateOnMount = _useFieldApi.validateOnMount,
    meta = _useFieldApi.meta,
    _useFieldApi$FormFiel = _useFieldApi.FormFieldGridProps,
    FormFieldGridProps = _useFieldApi$FormFiel === void 0 ? {} : _useFieldApi$FormFiel,
    _useFieldApi$inputPro = _useFieldApi.inputProps,
    inputProps = _useFieldApi$inputPro === void 0 ? {} : _useFieldApi$inputPro,
    rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded);
  var invalid = (0, _validationError.validationError)(meta, validateOnMount);
  return /*#__PURE__*/_react["default"].createElement(_formFieldGrid["default"], FormFieldGridProps, /*#__PURE__*/_react["default"].createElement(_TextField["default"], (0, _extends2["default"])({}, input, {
    fullWidth: true,
    error: !!invalid,
    helperText: invalid || (meta.touched || validateOnMount) && meta.warning || helperText || description,
    disabled: isDisabled,
    label: label,
    placeholder: placeholder,
    required: isRequired,
    inputProps: _objectSpread({
      readOnly: isReadOnly
    }, inputProps)
  }, rest, {
    multiline: true
  })));
};
var _default = exports["default"] = Textarea;