"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _clsx = _interopRequireDefault(require("clsx"));
var _selectNext = _interopRequireDefault(require("@data-driven-forms/common/wizard/select-next"));
var _formSpy = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/form-spy"));
var _Button = _interopRequireDefault(require("@mui/material/Button"));
var _Grid = _interopRequireDefault(require("@mui/material/Grid"));
var _excluded = ["buttons"];
var PREFIX = 'WizardStepButtons';
var classes = {
  wizardBody: "".concat(PREFIX, "-wizardBody"),
  buttons: "".concat(PREFIX, "-buttons"),
  button: "".concat(PREFIX, "-button"),
  buttonsContainer: "".concat(PREFIX, "-buttonsContainer")
};
var StyledGrid = (0, _styles.styled)(_Grid["default"])(function () {
  return (0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])({}, "& .".concat(classes.wizardBody), {
    padding: 24,
    margin: 0
  }), "& .".concat(classes.buttons), {
    display: 'flex',
    justifyContent: 'flex-end'
  }), "& .".concat(classes.button), {
    marginRight: 16
  }), "&.".concat(classes.buttonsContainer), {
    marginTop: 36
  });
});
var NextButton = function NextButton(_ref2) {
  var nextStep = _ref2.nextStep,
    valid = _ref2.valid,
    handleNext = _ref2.handleNext,
    nextLabel = _ref2.nextLabel,
    getState = _ref2.getState,
    handleSubmit = _ref2.handleSubmit,
    submitLabel = _ref2.submitLabel,
    conditionalSubmitFlag = _ref2.conditionalSubmitFlag;
  var nextResult = nextStep ? (0, _selectNext["default"])(nextStep, getState) : nextStep;
  var progressNext = nextResult !== conditionalSubmitFlag && nextStep;
  return /*#__PURE__*/_react["default"].createElement(_Button["default"], {
    variant: "contained",
    color: "primary",
    disabled: !valid || getState().validating || getState().submitting,
    onClick: function onClick() {
      return progressNext ? handleNext(nextResult) : handleSubmit();
    }
  }, progressNext ? nextLabel : submitLabel);
};
var WizardStepButtons = function WizardStepButtons(_ref3) {
  var Buttons = _ref3.buttons,
    props = (0, _objectWithoutProperties2["default"])(_ref3, _excluded);
  if (Buttons) {
    return /*#__PURE__*/_react["default"].createElement(Buttons, (0, _extends2["default"])({
      classes: classes
    }, props));
  }
  var disableBack = props.disableBack,
    handlePrev = props.handlePrev,
    nextStep = props.nextStep,
    handleNext = props.handleNext,
    _props$buttonLabels = props.buttonLabels,
    cancel = _props$buttonLabels.cancel,
    submit = _props$buttonLabels.submit,
    back = _props$buttonLabels.back,
    next = _props$buttonLabels.next,
    formOptions = props.formOptions,
    _props$ButtonContaine = props.ButtonContainerProps,
    ButtonContainerProps = _props$ButtonContaine === void 0 ? {} : _props$ButtonContaine,
    conditionalSubmitFlag = props.conditionalSubmitFlag;
  return /*#__PURE__*/_react["default"].createElement(StyledGrid, (0, _extends2["default"])({
    container: true,
    direction: "row",
    justifyContent: "space-evenly"
  }, ButtonContainerProps, {
    className: (0, _clsx["default"])(classes.buttonsContainer, ButtonContainerProps.className)
  }), /*#__PURE__*/_react["default"].createElement(_formSpy["default"], {
    subscription: {
      values: true,
      valid: true,
      validating: true,
      submitting: true
    }
  }, function () {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
      item: true,
      md: 2,
      xs: 2
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      onClick: formOptions.onCancel
    }, cancel)), /*#__PURE__*/_react["default"].createElement(_Grid["default"], {
      item: true,
      md: 10,
      xs: 10,
      className: classes.buttons
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      disabled: disableBack,
      onClick: handlePrev,
      className: classes.button
    }, back), /*#__PURE__*/_react["default"].createElement(NextButton, (0, _extends2["default"])({}, formOptions, {
      conditionalSubmitFlag: conditionalSubmitFlag,
      handleNext: handleNext,
      nextStep: nextStep,
      nextLabel: next,
      submitLabel: submit
    }))));
  }));
};
var _default = exports["default"] = WizardStepButtons;