"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _clsx = _interopRequireDefault(require("clsx"));
var _wizardContext = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/wizard-context"));
var _Grid = _interopRequireDefault(require("@mui/material/Grid"));
var _wizard = _interopRequireDefault(require("@data-driven-forms/common/wizard"));
var _wizardNav = _interopRequireDefault(require("./wizard-nav"));
var _stepButtons = _interopRequireDefault(require("./step-buttons"));
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var PREFIX = 'MuiWizard';
var classes = {
  wizardBody: "".concat(PREFIX, "-wizardBody")
};
var StyledWizard = (0, _styles.styled)(_Grid["default"])(function () {
  return (0, _defineProperty2["default"])({}, "& .".concat(classes.wizardBody), {
    padding: 24,
    margin: 0
  });
});
var WizardInternal = function WizardInternal(_ref2) {
  var buttonLabels = _ref2.buttonLabels,
    stepsInfo = _ref2.stepsInfo,
    ButtonContainerProps = _ref2.ButtonContainerProps,
    StepperProps = _ref2.StepperProps,
    _ref2$WizardBodyProps = _ref2.WizardBodyProps,
    WizardBodyProps = _ref2$WizardBodyProps === void 0 ? {} : _ref2$WizardBodyProps,
    WizardProps = _ref2.WizardProps,
    conditionalSubmitFlag = _ref2.conditionalSubmitFlag;
  var _useContext = (0, _react.useContext)(_wizardContext["default"]),
    formOptions = _useContext.formOptions,
    currentStep = _useContext.currentStep,
    handlePrev = _useContext.handlePrev,
    onKeyDown = _useContext.onKeyDown,
    handleNext = _useContext.handleNext,
    activeStepIndex = _useContext.activeStepIndex,
    prevSteps = _useContext.prevSteps;
  var buttonLabelsFinal = _objectSpread({
    next: 'Continue',
    submit: 'Submit',
    cancel: 'Cancel',
    back: 'Back'
  }, buttonLabels);
  return /*#__PURE__*/_react["default"].createElement(StyledWizard, (0, _extends2["default"])({
    container: true
  }, WizardProps, {
    onKeyDown: onKeyDown
  }), stepsInfo && /*#__PURE__*/_react["default"].createElement(_wizardNav["default"], {
    StepperProps: StepperProps,
    stepsInfo: stepsInfo,
    activeStepIndex: activeStepIndex
  }), /*#__PURE__*/_react["default"].createElement(_Grid["default"], (0, _extends2["default"])({
    container: true,
    spacing: 2
  }, WizardBodyProps, {
    className: (0, _clsx["default"])(classes.wizardBody, WizardBodyProps.className)
  }), currentStep.fields.map(function (item) {
    return formOptions.renderForm([item], formOptions);
  }), /*#__PURE__*/_react["default"].createElement(_stepButtons["default"], (0, _extends2["default"])({}, currentStep, {
    formOptions: formOptions,
    buttonLabels: buttonLabelsFinal,
    handleNext: handleNext,
    handlePrev: handlePrev,
    disableBack: prevSteps.length === 0,
    conditionalSubmitFlag: conditionalSubmitFlag,
    ButtonContainerProps: ButtonContainerProps
  }))));
};
var MuiWizard = function MuiWizard(props) {
  return /*#__PURE__*/_react["default"].createElement(_wizard["default"], (0, _extends2["default"])({
    Wizard: WizardInternal
  }, props));
};
var _default = exports["default"] = MuiWizard;